; ==============================================================================
;	Graphic datas
;
;  Copyright (C) 2020 Takayuki Hara (HRA!)
;  All rights reserved.
;                           http://hraroom.s602.xrea.com/msx/software/mgsp.html
;
;  {\tgEFAі{\tgEFAɊÂč쐬ꂽh́Aȉ̏
;  ꍇɌAĔЕzюgp܂B
;
;  1.\[XR[h`ōĔЕzꍇAL̒쌠\A{ꗗAщL
;    Ɛӏ̂܂܂̌`ŕێ邱ƁB
;  2.oCi`ōĔЕzꍇAЕzɕt̃hLg̎ɁAL
;    쌠\A{ꗗAщLƐӏ܂߂邱ƁB
;  3.ʂɂ鎖ŐȂɁA{\tgEFA̔AяƓIȐi⊈
;    ɎgpȂƁB
;
;  {\tgEFÁA쌠҂ɂāû܂܁v񋟂Ă܂B쌠҂́A
;  ړIւ̓K̕ۏ؁Ai̕ۏ؁A܂Ɍ肳ȂAȂ閾
;  I͈ÖقȕۏؐӔC܂B쌠҂́AR̂킸AQ
;  ̌킸AӔC̍_ł邩iӔCł邩iߎ
;  ̑́js@sׂł邩킸Aɂ̂悤ȑQ\m
;  ĂƂĂA{\tgEFA̎gpɂĔi֕i܂͑pT
;  [rX̒BAgp̑rAf[^̑rAv̑rAƖ̒f܂߁A܂
;  Ɍ肳ȂjڑQAԐڑQAIȑQAʑQAIQA
;  ͌ʑQɂāAؐӔC𕉂Ȃ̂Ƃ܂B
;
;  Note that above Japanese version license is the formal document.
;  The following translation is only for reference.
;
;  Redistribution and use of this software or any derivative works,
;  are permitted provided that the following conditions are met:
;
;  1. Redistributions of source code must retain the above copyright
;     notice, this list of conditions and the following disclaimer.
;  2. Redistributions in binary form must reproduce the above
;     copyright notice, this list of conditions and the following
;     disclaimer in the documentation and/or other materials
;     provided with the distribution.
;  3. Redistributions may not be sold, nor may they be used in a
;     commercial product or activity without specific prior written
;     permission.
;
;  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
;  "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
;  LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
;  FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
;  COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
;  INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
;  BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
;  LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
;  CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
;  LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
;  ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
;  POSSIBILITY OF SUCH DAMAGE.
; ------------------------------------------------------------------------------
;	Date		Author	Ver		Description
;	2020/10/25	t.hara	1.0		1st release, separated from GRAPHIC.ASM
; ==============================================================================

; ==============================================================================
;	WORKAREA (Read/Write)
; ==============================================================================
grp_select_line_on::			; 0: undisplay, 1: display
		db		1
grp_file_list_mode::			; 0: Ȗ\[h, 1: t@C\[h
		db		0
grp_top_file::					; t@CXg̈ԏɕ\Ăt@C̃CfbNX (255͔\)
		db		255
grp_select_file::				; J[\̈ʒũt@C̃CfbNX
		db		0
grp_play_file::					; Đ̃t@C̃CfbNX (255͒~)
		db		255
grp_select_line_no::			; J[\̈ʒu̍sԍ (0`10)
		db		0
grp_no_title::					; Ȗ܂܂ȂMGSt@C̏ꍇ̈ꗗ\
		ds		"No title ["
grp_no_title_file_name::		; ̓t@Cŏ㏑
		ds		"        "
		ds		"]"
		db		0
grp_track_volume:				; +0: current volume level, +1: track volume level
		db		0, 0			; track 1
		db		0, 0			; track 2
		db		0, 0			; track 3
		db		0, 0			; track 4
		db		0, 0			; track 5
		db		0, 0			; track 6
		db		0, 0			; track 7
		db		0, 0			; track 8
		db		0, 0			; track 9
		db		0, 0			; track A
		db		0, 0			; track B
		db		0, 0			; track C
		db		0, 0			; track D
		db		0, 0			; track E
		db		0, 0			; track F
		db		0, 0			; track G
		db		0, 0			; track H

; ==============================================================================
;	WORKAREA (Read only)
; ==============================================================================
theme_start::
grp_color_scroll_bar_blank::
		db		0x44
grp_color_scroll_bar_knob::
		db		0x47
grp_color_scroll_bar_none::
		db		0x45
grp_color_cursor::
		db		0x0B
grp_color_cursor_playing::
		db		0x09
grp_color_playing::
		db		0x06
thene_end::

grp_help_table::			; wvbZ[WXg
		dw		grp_help_line1, grp_help_line2, grp_help_line3, grp_help_line4
		dw		grp_help_line5, grp_help_line6, grp_help_line7, grp_help_line8
		dw		grp_help_line9, grp_help_line10, grp_help_line11

grp_help_line1::
		ds		"[][][][][-][+] - Select file."
		db		0
grp_help_line2::
		ds		"[F9][HOME] ------------- Toggle auto play mode."
		db		0
grp_help_line3::
		ds		"[F1][SPACE][RETURN] ---- Load and play selected file."
		db		0
grp_help_line4::
		ds		"[F10][ESC] ------------- Exit MGSP."
		db		0
grp_help_line5::
		ds		"[F6][P] ---------------- Play loaded file."
		db		0
grp_help_line6::
		ds		"[F7][INS]/[F8][DEL] ---- Master volume down/up."
		db		0
grp_help_line7::
		ds		"[Z]/[X] ---------------- Loop counter down/up."
		db		0
grp_help_line8::
		ds		"[N]/[T]/[E] ------------ Sort files (Normal/Title/FileName)"
		db		0
grp_help_line9::
		ds		"[F2][S] ---------------- Stop song."
		db		0
grp_help_line10::
		ds		"[F3][F] ---------------- Fadeout and change to next file."
		db		0
grp_help_line11::
		ds		"[F4][BS]/[1] ... [8] --- Move up one directory./Change drive."
		db		0

grp_directory_mark::
		ds		"[DIR] "
mgsp_name::
		ds		"MGSP"
mgsp_version::
		ds		" Version 2.1.0 alpha"
		db		0
mgsp_copyright::
		ds		"Copyright (C)2020 HRA!"
		db		0
mgsp_order::
		ds		"Order  :"
		db		0
mgsp_order_entry::			; 8bytes
		ds		"Entry"
		db		0, 0, 0
mgsp_order_title::			; 8bytes
		ds		"Title"
		db		0, 0, 0
mgsp_order_filename::		; 8bytes
		ds		"F.Name"
		db		0, 0
mgsp_volume::
		ds		"Volume :"
		db		0
mgsp_automode::
		ds		"Mode :"
		db		0
mgsp_normal_mode::			; 8bytes
		ds		"Normal"
		db		0, 0
mgsp_random_mode::			; 8bytes
		ds		"Random"
		db		0, 0
mgsp_repeat_mode::			; 8bytes
		ds		"Repeat"
		db		0, 0
mgsp_ch::
		ds		" 1 2 3 4 5 6 7 8 9 A B C D E F G H"
		db		0
mgsp_loop_count::
		ds		"Loop :"
		db		0
mgsp_filename::
		ds		"Filename: "
		db		0
mgsp_drive::
		ds		"Drive: "
		db		0
mgsp_filename_line::		; t@Cꗗ̍sɑΉ鍶[ PCGԍ
		db		96, 127, 158, 189, 220, 6, 37, 68, 99, 130, 161
grp_volume_table::			; MasterVolumeɑ΂ݒl (0ő) ɑΉ鉹ʕ\p^[
		db		0b11111111, 0b11111111
		db		0b11111111, 0b11111110
		db		0b11111111, 0b11111100
		db		0b11111111, 0b11111000
		db		0b11111111, 0b11110000
		db		0b11111111, 0b11100000
		db		0b11111111, 0b11000000
		db		0b11111111, 0b10000000
		db		0b11111111, 0b00000000
		db		0b11111110, 0b00000000
		db		0b11111100, 0b00000000
		db		0b11111000, 0b00000000
		db		0b11110000, 0b00000000
		db		0b11100000, 0b00000000
		db		0b11000000, 0b00000000
		db		0b10000000, 0b00000000

mgsp_keyboard_spot_pattern::
		db		0xAA				; i +0
		db		0xAA				; i +1
		db		0xAA				; i +2
		db		0xAA				; i +3
		db		0xAA				; i +4
		db		0xAA				; i +5
		db		0xAA				; i +6
		db		0xA2				; i +7
		db		0xA2				; i +8
		db		0x8A				; i +9
		db		0x8A				; i +10
		db		0x2A				; i +11
		db		0x28				; i +12
		db		0xA8				; i +13
		db		0xAA				; i +14
		db		0xAA				; i +15
		db		0xAA				; i +16
		db		0xAA				; i +17
		db		0xAA				; i +18
		db		0xAA				; i +19
		db		0xAA				; i +20
		db		0xA2				; i +21
		db		0xA2				; i +22
		db		0x8A				; i +23
		db		0x8A				; i +24
		db		0x2A				; i +25
		db		0x28				; i +26
		db		0xA8				; i +27

mgsp_tone_to_keyboard::
		db		0    , 0x80			; O0C  --> i
		db		7    , 0x80			; O0C# --> i
		db		0    , 0x20			; O0D  --> i
		db		7    , 0x20			; O0D# --> i
		db		0    , 0x08			; O0E  --> i
		db		0    , 0x02			; O0F  --> i
		db		7    , 0x02			; O0F# --> i
		db		1    , 0x80			; O0G  --> i
		db		8    , 0x80			; O0G# --> i
		db		1    , 0x20			; O0A  --> i
		db		8    , 0x20			; O0A# --> i
		db		1    , 0x08			; O0B  --> i
		db		1    , 0x02			; O1C  --> i
		db		8    , 0x02			; O1C# --> i
		db		2    , 0x80			; O1D  --> i
		db		9    , 0x80			; O1D# --> i
		db		2    , 0x20			; O1E  --> i
		db		2    , 0x08			; O1F  --> i
		db		9    , 0x08			; O1F# --> i
		db		2    , 0x02			; O1G  --> i
		db		9    , 0x02			; O1G# --> i
		db		3    , 0x80			; O1A  --> i
		db		10   , 0x80			; O1A# --> i
		db		3    , 0x20			; O1B  --> i
		db		3    , 0x08			; O2C  --> i
		db		10   , 0x08			; O2C# --> i
		db		3    , 0x02			; O2D  --> i
		db		10   , 0x02			; O2D# --> i
		db		4    , 0x80			; O2E  --> i
		db		4    , 0x20			; O2F  --> i
		db		11   , 0x20			; O2F# --> i
		db		4    , 0x08			; O2G  --> i
		db		11   , 0x08			; O2G# --> i
		db		4    , 0x02			; O2A  --> i
		db		11   , 0x02			; O2A# --> i
		db		5    , 0x80			; O2B  --> i
		db		5    , 0x20			; O3C  --> i
		db		12   , 0x20			; O3C# --> i
		db		5    , 0x08			; O3D  --> i
		db		12   , 0x08			; O3D# --> i
		db		5    , 0x02			; O3E  --> i
		db		6    , 0x80			; O3F  --> i
		db		13   , 0x80			; O3F# --> i
		db		6    , 0x20			; O3G  --> i
		db		13   , 0x20			; O3G# --> i
		db		6    , 0x08			; O3A  --> i
		db		13   , 0x08			; O3A# --> i
		db		6    , 0x02			; O3B  --> i

		db		0 +14, 0x80			; O4C  --> i
		db		7 +14, 0x80			; O4C# --> i
		db		0 +14, 0x20			; O4D  --> i
		db		7 +14, 0x20			; O4D# --> i
		db		0 +14, 0x08			; O4E  --> i
		db		0 +14, 0x02			; O4F  --> i
		db		7 +14, 0x02			; O4F# --> i
		db		1 +14, 0x80			; O4G  --> i
		db		8 +14, 0x80			; O4G# --> i
		db		1 +14, 0x20			; O4A  --> i
		db		8 +14, 0x20			; O4A# --> i
		db		1 +14, 0x08			; O4B  --> i
		db		1 +14, 0x02			; O5C  --> i
		db		8 +14, 0x02			; O5C# --> i
		db		2 +14, 0x80			; O5D  --> i
		db		9 +14, 0x80			; O5D# --> i
		db		2 +14, 0x20			; O5E  --> i
		db		2 +14, 0x08			; O5F  --> i
		db		9 +14, 0x08			; O5F# --> i
		db		2 +14, 0x02			; O5G  --> i
		db		9 +14, 0x02			; O5G# --> i
		db		3 +14, 0x80			; O5A  --> i
		db		10+14, 0x80			; O5A# --> i
		db		3 +14, 0x20			; O5B  --> i
		db		3 +14, 0x08			; O6C  --> i
		db		10+14, 0x08			; O6C# --> i
		db		3 +14, 0x02			; O6D  --> i
		db		10+14, 0x02			; O6D# --> i
		db		4 +14, 0x80			; O6E  --> i
		db		4 +14, 0x20			; O6F  --> i
		db		11+14, 0x20			; O6F# --> i
		db		4 +14, 0x08			; O6G  --> i
		db		11+14, 0x08			; O6G# --> i
		db		4 +14, 0x02			; O6A  --> i
		db		11+14, 0x02			; O6A# --> i
		db		5 +14, 0x80			; O6B  --> i
		db		5 +14, 0x20			; O7C  --> i
		db		12+14, 0x20			; O7C# --> i
		db		5 +14, 0x08			; O7D  --> i
		db		12+14, 0x08			; O7D# --> i
		db		5 +14, 0x02			; O7E  --> i
		db		6 +14, 0x80			; O7F  --> i
		db		13+14, 0x80			; O7F# --> i
		db		6 +14, 0x20			; O7G  --> i
		db		13+14, 0x20			; O7G# --> i
		db		6 +14, 0x08			; O7A  --> i
		db		13+14, 0x08			; O7A# --> i
		db		6 +14, 0x02			; O7B  --> i
